Unit MNT1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, GSU2R_p;

procedure MNT1R(N :Integer; M :Integer; var A :Array of Real;
                var B :Array of Real; var X :Array of Real;
                var R :Array of Real; LIMIT :Integer;
                var S :Array of Integer; XE :Real;
                var RM :Array of Real; var IERR :Integer);

implementation

procedure MNT1R(N :Integer; M :Integer; var A :Array of Real;
                var B :Array of Real; var X :Array of Real;
                var R :Array of Real; LIMIT :Integer;
                var S :Array of Integer; XE :Real;
                var RM :Array of Real; var IERR :Integer);
var
I,ISEED,ISEED1,J,K,L :Integer;
AL,F,R1,C,Z :Real;
const
E :Real = 1.0E-15;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130;
begin
ISEED := 1287108;
for I:=1 to N do
 begin
  X[I-1] := 0.0;
  R[I-1] := -B[I-1];
_10:
 end;
for I:=1 to LIMIT do
 begin
  for J:=1 to N do
   begin
    S[J-1] := 0;
_20:
   end;
  for K:=1 to M do
   begin
    Z := GSU2R(ISEED);
    L := Trunc( Z*N+1 );
    S[L-1] := 1;
_30:
   end;
  AL := 0.0;
  for K:=1 to N do
   begin
    if ( S[K-1] = 0 )
     then goto _40;
    AL := AL+R[K-1];
_40:
   end;
  for K:=1 to N do
   begin
    RM[K-1] := 0.0;
    for L:=1 to N do
     begin
      if ( S[L-1] = 0 ) 
       then goto _50;
      RM[K-1] := RM[K-1]+A[(K-1)+(L-1)*N];
_50:
     end;
_60:
   end;
  R1 := 0.0;
  for K:=1 to N do
   begin
    if ( S[K-1] = 0 ) 
     then goto _70;
    R1 := R1+RM[K-1];
_70:
   end;
  if ( Abs(R1) <= E )
   then goto _110;
  AL := -AL/R1;
  for J:=1 to N do
   begin
    if ( S[J-1] = 0 ) 
     then goto _90;
    X[J-1] := X[J-1]+AL;
    for L:=1 to N do
     begin
      R[L-1] := R[L-1]+AL*A[(L-1)+(J-1)*N];
_80:
     end;
_90:
   end;
  F := 0.0;
  for J:=1 to N do
   begin
    R1 := Abs(R[J-1]);
    if ( R1 > F )
     then F := R1;
_100:
   end;
  if ( F <= XE )
   then goto _120;
_110:
 end;
IERR := 1;
goto _130;
_120:
IERR := 0;
_130:
end;

end.
